--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   20:08:31 01/10/2007
-- Design Name:   DualPortSram
-- Module Name:   C:/Xilinx/Projects/VGA/VGA3/DualPort_TB.vhd
-- Project Name:  VGA3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: DualPortSram
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY DualPort_TB_vhd IS
END DualPort_TB_vhd;

ARCHITECTURE behavior OF DualPort_TB_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT DualPortSram
	PORT(
		reset : IN std_logic;
		clk : IN std_logic;
		rd1 : IN std_logic;
		rd2 : IN std_logic;
		wr2 : IN std_logic;    
		Addr1 : INOUT std_logic_vector(14 downto 0);
		Addr2 : INOUT std_logic_vector(14 downto 0);
		DataIn2 : INOUT std_logic_vector(7 downto 0);
		SRData : INOUT std_logic_vector(7 downto 0);      
		DataOut1 : OUT std_logic_vector(7 downto 0);
		done1 : OUT std_logic;
		DataOut2 : OUT std_logic_vector(7 downto 0);
		done2 : OUT std_logic;
		SRAddr : OUT std_logic_vector(14 downto 0);
		SR_OE : OUT std_logic;
		SR_CS : OUT std_logic;
		SR_WR : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset :  std_logic := '1';
	SIGNAL clk :  std_logic := '0';
	SIGNAL rd1 :  std_logic := '0';
	SIGNAL rd2 :  std_logic := '0';
	SIGNAL wr2 :  std_logic := '0';

	--BiDirs
	SIGNAL Addr1 :  std_logic_vector(14 downto 0);
	SIGNAL Addr2 :  std_logic_vector(14 downto 0);
	SIGNAL DataIn2 :  std_logic_vector(7 downto 0);
	SIGNAL SRData :  std_logic_vector(7 downto 0);

	--Outputs
	SIGNAL DataOut1 :  std_logic_vector(7 downto 0);
	SIGNAL done1 :  std_logic;
	SIGNAL DataOut2 :  std_logic_vector(7 downto 0);
	SIGNAL done2 :  std_logic;
	SIGNAL SRAddr :  std_logic_vector(14 downto 0);
	SIGNAL SR_OE :  std_logic;
	SIGNAL SR_CS :  std_logic;
	SIGNAL SR_WR :  std_logic;

constant clock_period: time := 10 ns;  -- 5 ns for 100 MHz, 10 ns for 50 MHz

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: DualPortSram PORT MAP(
		reset => reset,
		clk => clk,
		Addr1 => Addr1,
		DataOut1 => DataOut1,
		rd1 => rd1,
		done1 => done1,
		Addr2 => Addr2,
		DataOut2 => DataOut2,
		DataIn2 => DataIn2,
		rd2 => rd2,
		wr2 => wr2,
		done2 => done2,
		SRAddr => SRAddr,
		SRData => SRData,
		SR_OE => SR_OE,
		SR_CS => SR_CS,
		SR_WR => SR_WR
	);
	
	clockgen: PROCESS
	BEGIN
          clk <= '1' after clock_period, '0' after clock_period*2;
	  wait until clk = '0';
	END PROCESS;

	tb : PROCESS
	BEGIN
	  wait for clock_period*2;
          Reset <= '0';
	  wait for 50ns;
	  
	  Addr1 <= std_logic_vector(to_unsigned(1,Addr1'LENGTH));
	  Addr2 <= std_logic_vector(to_unsigned(2,Addr2'LENGTH));
	  DataIn2 <= "11111111";
	  rd1 <= '1';
	  wr2 <= '1';
	  wait for 50ns;
	  rd1 <= '0';
	  wr2 <= '0';
	  wait for 500ns;
--		wait; -- will wait forever
	END PROCESS;

END;
