--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   21:41:38 01/16/2007
-- Design Name:   ECB_BusIntf
-- Module Name:   C:/Xilinx/Projects/VGA/VGA3/ECB_BusIntf_Testbench.vhd
-- Project Name:  VGA3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ECB_BusIntf
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY ECB_BusIntf_Testbench_vhd IS
END ECB_BusIntf_Testbench_vhd;

ARCHITECTURE behavior OF ECB_BusIntf_Testbench_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT ECB_BusIntf
	PORT(
		res_n : IN std_logic;
		ECB_clk : IN std_logic;
		rd_n : IN std_logic;
		wr_n : IN std_logic;
		iorq_n : IN std_logic;
		A : IN std_logic_vector(7 downto 0);
		KbdChar_i : IN std_logic_vector(7 downto 0);
		KbdCharAvail_i : IN std_logic;
		TermReady : IN std_logic;    
		D : INOUT std_logic_vector(7 downto 0);      
		KbdCharProcessed_o : OUT std_logic;
		TermChar_o : OUT std_logic_vector(7 downto 0);
		TermCharAvail_o : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL res_n :  std_logic := '0';
	SIGNAL ECB_clk :  std_logic := '0';
	SIGNAL rd_n :  std_logic := '1';
	SIGNAL wr_n :  std_logic := '1';
	SIGNAL iorq_n :  std_logic := '1';
	SIGNAL KbdCharAvail_i :  std_logic := '1';
	SIGNAL TermReady :  std_logic := '1';
	SIGNAL A :  std_logic_vector(7 downto 0) := (others=>'0');
	SIGNAL KbdChar_i :  std_logic_vector(7 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL D :  std_logic_vector(7 downto 0);

	--Outputs
	SIGNAL KbdCharProcessed_o :  std_logic;
	SIGNAL TermChar_o :  std_logic_vector(7 downto 0);
	SIGNAL TermCharAvail_o :  std_logic;
        constant clock_period: time := 20 ns;  -- 5 ns for 100 MHz, 10 ns for 50 MHz
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: ECB_BusIntf PORT MAP(
		res_n => res_n,
		ECB_clk => ECB_clk,
		rd_n => rd_n,
		wr_n => wr_n,
		iorq_n => iorq_n,
		A => A,
		D => D,
		KbdChar_i => KbdChar_i,
		KbdCharAvail_i => KbdCharAvail_i,
		KbdCharProcessed_o => KbdCharProcessed_o,
		TermChar_o => TermChar_o,
		TermCharAvail_o => TermCharAvail_o,
		TermReady => TermReady
	);
	
	clockgen: PROCESS
	BEGIN
          ECB_clk <= '1' after clock_period, '0' after clock_period*2;
	  wait until ECB_clk = '0';
	END PROCESS;


	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- Place stimulus here
		res_n <= '1';

--		wait until ECB_clk = '1'; wait for 10 ns;
--		A <= x"11"; --A <= x"10";
--		wait until ECB_clk = '1'; wait for 10 ns;
--		-- read status port
--		rd_n <= '0'; iorq_n <= '0';
--		wait for 60 ns;
--		wait until ECB_clk = '0'; wait for 10 ns;
--		iorq_n <= '1'; rd_n <= '1';
--		wait for 60 ns;
		
		-- write Terminal Data
		wait until ECB_clk = '1'; wait for 10 ns;
		A <= x"11"; D <= x"5A";
		wait until ECB_clk = '1'; wait for 10 ns;
		wr_n <= '0'; iorq_n <= '0';
		wait for 60 ns;
		wait until ECB_clk = '0'; wait for 10 ns;
		iorq_n <= '1'; wr_n <= '1';
		wait for 60 ns;


		wait; -- will wait forever
	END PROCESS;

END;
