
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:14:46 01/03/2007
-- Design Name:   VGASignal
-- Module Name:   C:/Xilinx/Projects/VGA/VGA3/VGASignal_TB.vhd
-- Project Name:  VGA3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: VGASignal
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY VGASignal_TB_vhd IS
END VGASignal_TB_vhd;

ARCHITECTURE behavior OF VGASignal_TB_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT VGASignal
	PORT(
		reset : IN std_logic;
		Clk25M : IN std_logic;
		CharPixel : IN std_logic_vector(7 downto 0);
		ChariRGB : IN std_logic_vector(7 downto 0);
		CharReady : IN std_logic;          
		GetPixelDataClk : OUT std_logic;
		ColCharCount : OUT std_logic_vector(7 downto 0);
		LinePixCount : OUT std_logic_vector(9 downto 0);
		hsync_out : OUT std_logic;
		vsync_out : OUT std_logic;
		red_out : OUT std_logic_vector(2 downto 0);
		green_out : OUT std_logic_vector(2 downto 0);
		blue_out : OUT std_logic_vector(2 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL reset :  std_logic := '1';
	SIGNAL Clk25M :  std_logic := '0';
	SIGNAL CharReady :  std_logic := '0';
	SIGNAL CharPixel :  std_logic_vector(7 downto 0) := (others=>'0');
	SIGNAL ChariRGB :  std_logic_vector(7 downto 0) := (others=>'0');

	--Outputs
	SIGNAL GetPixelDataClk :  std_logic;
	SIGNAL ColCharCount :  std_logic_vector(7 downto 0);
	SIGNAL LinePixCount :  std_logic_vector(9 downto 0);
	SIGNAL hsync_out :  std_logic;
	SIGNAL vsync_out :  std_logic;
	SIGNAL red_out :  std_logic_vector(2 downto 0);
	SIGNAL green_out :  std_logic_vector(2 downto 0);
	SIGNAL blue_out :  std_logic_vector(2 downto 0);
	
        constant clock_period: time := 20 ns;  -- 5 ns for 100 MHz, 10 ns for 50 MHz

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: VGASignal PORT MAP(
		reset => reset,
		Clk25M => Clk25M,
		GetPixelDataClk => GetPixelDataClk,
		ColCharCount => ColCharCount,
		LinePixCount => LinePixCount,
		CharPixel => CharPixel,
		ChariRGB => ChariRGB,
		CharReady => CharReady,
		hsync_out => hsync_out,
		vsync_out => vsync_out,
		red_out => red_out,
		green_out => green_out,
		blue_out => blue_out
	);
	
	clockgen: PROCESS
	BEGIN
--	  clk25M <= '0';
--	  wait for clock_period;
	  
--	  clk25M <= '1';
--	  wait for clock_period;
          clk25M <= '1' after clock_period, '0' after clock_period*2;
	  wait until clk25M = '0';
	END PROCESS;


-- Z <= transport Y after 10 ns;
-- Z <= 3 after 5 ns, 21 after 10 ns, 14 after 17 ns;
	
	chargen: PROCESS (GetPixelDataClk,clk25M)
	VARIABLE Count : INTEGER := 0;
	VARIABLE Char : STD_LOGIC_VECTOR(7 DOWNTO 0) := "00000001";
	BEGIN
	  IF Rising_Edge(Clk25M) THEN
  	    IF (GetPixelDataClk = '1') AND (Count = 0) THEN
	      Count := 1;
	    END IF;
	    IF Count > 0 THEN
	      Count := Count + 1;
	      IF Count = 8 THEN		-- 8 * 40ns -> 320 ns (absolute maximum @ 25MHz Pixel clock)
	        CharPixel <= Char;
		Char := Char + 1;
		ChariRGB  <= "00001111";
	        CharReady <= '1'; 
	      END IF;
	      IF Count = 9 THEN
  	        CharReady <= '0';
		Count := 0;
	      END IF;
	    END IF;
	  END IF;
	END PROCESS;



	tb : PROCESS
        variable i : integer;
	BEGIN

		-- Wait 100 ns for global reset to finish
--		wait for 100 ns;
--                Reset <= '1';
                wait for clock_period*2;
                Reset <= '0';

		-- Place stimulus here
--                for i in 0 to 800*300 loop
--                  clk25M <= NOT clk25M; wait for clock_period;  -- now 0
--                  clk25M <= NOT clk25M; wait for clock_period;  -- now 1
--                end loop;

		wait; -- will wait forever
	END PROCESS;
        
END;
