
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:47:05 01/04/2007
-- Design Name:   VGA
-- Module Name:   C:/Xilinx/Projects/VGA/VGA3/VGA_TB.vhd
-- Project Name:  VGA3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: VGA
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY VGA_TB_vhd IS
END VGA_TB_vhd;

ARCHITECTURE behavior OF VGA_TB_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT VGA
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;          
		red_out : OUT std_logic_vector(2 downto 0);
		green_out : OUT std_logic_vector(2 downto 0);
		blue_out : OUT std_logic_vector(2 downto 0);
		vsync_out : OUT std_logic;
		hsync_out : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL reset :  std_logic := '0';

	--Outputs
	SIGNAL red_out :  std_logic_vector(2 downto 0);
	SIGNAL green_out :  std_logic_vector(2 downto 0);
	SIGNAL blue_out :  std_logic_vector(2 downto 0);
	SIGNAL vsync_out :  std_logic;
	SIGNAL hsync_out :  std_logic;
        constant clock_period: time := 10 ns;
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: VGA PORT MAP(
		clk => clk,
		red_out => red_out,
		green_out => green_out,
		blue_out => blue_out,
		vsync_out => vsync_out,
		hsync_out => hsync_out,
		reset => reset
	);

	tb : PROCESS
	BEGIN

		wait for 100 ns;
                Reset <= '1';
                wait for 50 ns;
                Reset <= '0';

		-- Place stimulus here
                for i in 0 to 800*300 loop
                  
                  clk <= NOT clk; wait for clock_period;  -- now 1
                  clk <= NOT clk; wait for clock_period;  -- now 0
                
                end loop;

		wait; -- will wait forever
	END PROCESS;

END;
