--------------------------------------------------------------------------------
-- Engineer:		Armin Diehl
--
-- Create Date:		19:22:37 01/15/2007
-- Design Name:		ps2kbdTranslate_TB
-- Project Name:	VGA3
-- Target Device:  
-- Tool versions:  
-- Description:		some tests for ps2kbdtranslate
-- 
-- VHDL Test Bench Created by ISE for module: ps2kbdTranslate
--
-- Revision:
-- Revision 0.01 - File Created
--------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY ps2kbdTranslate_TB_vhd IS
END ps2kbdTranslate_TB_vhd;

ARCHITECTURE behavior OF ps2kbdTranslate_TB_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT ps2kbdTranslate
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		keyavail_i : IN std_logic;
		keyData_i : IN std_logic_vector(7 downto 0);
		sendFinished_i : IN std_logic;
		CharClear_i : IN std_logic;          
		sendData_o : OUT std_logic_vector(7 downto 0);
		sendAvail_o : OUT std_logic;
		keyClear_o : OUT std_logic;
		CharData_o : OUT std_logic_vector(7 downto 0);
		CharAvail_o : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL reset :  std_logic := '0';
	SIGNAL keyavail_i :  std_logic := '0';
	SIGNAL sendFinished_i :  std_logic := '0';
	SIGNAL CharClear_i :  std_logic := '0';
	SIGNAL keyData_i :  std_logic_vector(7 downto 0) := (others=>'0');

	--Outputs
	SIGNAL sendData_o :  std_logic_vector(7 downto 0);
	SIGNAL sendAvail_o :  std_logic;
	SIGNAL keyClear_o :  std_logic;
	SIGNAL CharData_o :  std_logic_vector(7 downto 0);
	SIGNAL CharAvail_o :  std_logic;
	constant clock_period: time := 20 ns;  -- 5 ns for 100 MHz, 10 ns for 50 MHz
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: ps2kbdTranslate PORT MAP(
		clk => clk,
		reset => reset,
		keyavail_i => keyavail_i,
		keyData_i => keyData_i,
		sendData_o => sendData_o,
		sendAvail_o => sendAvail_o,
		sendFinished_i => sendFinished_i,
		keyClear_o => keyClear_o,
		CharData_o => CharData_o,
		CharAvail_o => CharAvail_o,
		CharClear_i => CharClear_i
	);
	
	clockgen: PROCESS
	BEGIN
          clk <= '1' after clock_period, '0' after clock_period*2;
	  wait until clk = '0';
	END PROCESS;


	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		reset <= '1';
		wait for 40 ns;
		reset <= '0';

		-- Place stimulus here
		
		keyData_i <= x"e0";	-- extended key
		keyavail_i <= '1';
		wait for 40 ns;
		keyavail_i <= '0';
		wait for 40 ns;
		
		keyData_i <= x"69";	-- E0 69, END
		keyavail_i <= '1';
		wait for 40 ns;
		keyavail_i <= '0';
		wait for 40 ns;
		
		wait until CharAvail_o = '1';
		wait for 80 ns;
		CharClear_i <= '1';
		wait until CharAvail_o = '0';
		CharClear_i <= '0';
		
		wait until CharAvail_o = '1';
		wait for 80 ns;
		CharClear_i <= '1';
		wait until CharAvail_o = '0';
		CharClear_i <= '0';
		
		
		
		
		wait; -- will wait forever
		
	END PROCESS;

END;
